#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

char *vol = "01";

typedef struct title { /* Comments : Zeile beginnt mit #                */
  char *a;          /* Autor  erstes Feld eines Titels beginnt mit   \A */
  char *t;          /* title           Feld beginnt mit \T              */
  char *c;          /* html comments   Feld beginnt mit \C              */
  char *d;          /* html comments   Feld beginnt mit \D              */
  char *x;          /* tex comments    Feld beginnt mit \X              */
  int   pp;         /* pages           Feld beginnt mit \P              */
  int   f;          /* erste Seite                                      */
  struct title *n;  /* naechster title                                  */
  struct title *p;  /* vorangehender title                              */
} title;
extern void *malloc();
void *emalloc(int n) {
  void *p;
  if ( (p=(void *)malloc(n)) == NULL) {
    fprintf(stderr,"malloc: Nicht genug Speicher\n");
    exit(1);
  }
  else
    return p;
}
FILE *eopen(char *path, char *mode) {
  FILE *fp;
  if ( (fp=fopen(path, mode)) == NULL) {
    fprintf(stderr,\
    "fopen:Datei %s kann nicht im Mode %s geoeffnet werden\n",path,mode);
    exit(1);
  }
  else
    return fp;
}
    
int isblank(char c) {
  return ( c==' ' || c=='\t' || c=='\n' ) ? 1 : 0;
}
/* Konstruktor fuer title, ohne Initialisierung von f */
title *Title(char *a, char *t, char *c, char *d,  char *x, int pp, title *n, title *p) {
  title *T;
  T = (title *)(emalloc(sizeof(title)));
  if (a) {
    while ( isblank(*a++) ) ; a--;
    T->a = (char *)emalloc(strlen(a) + 1); strcpy(T->a,a);
  }
  else T->a = 0;
  if (t) {
    while ( isblank(*t++) ) ; t--;
    T->t = (char *)emalloc(strlen(t) + 1); strcpy(T->t,t);
  }
  else T->t = 0;
  if (c) {
    while ( isblank(*c++) ) ; c--;
    T->c = (char *)emalloc(strlen(c) + 1); strcpy(T->c,c);
  }
  else T->c = 0;
  if (d) {
    while ( isblank(*d++) ) ; d--;
    T->d = (char *)emalloc(strlen(d) + 1); strcpy(T->d,d);
  }
  else T->d = 0;
  if (x) {
    while ( isblank(*x++) ) ; x--;
    T->x = (char *)emalloc(strlen(x) + 1); strcpy(T->x,x);
  }
  else T->x = 0;
  T->pp = pp; T->n = n; T->p = p;
  return T;
}

#define LEN 1000
char  a[LEN]; /* Autor        */
char  t[LEN]; /* Titel        */
char  c[LEN]; /* HTML comment */
char  d[LEN]; /* HTML comment */
char  x[LEN]; /* Tex  comment */
char  pp[10]; /* String fuer Seitenzahl */

FILE *data, *tex;   /* Quelle, tex-Ziel, html-Ziel    */
int first, last;                   /* Erste, letzte Seite,           */

int count=0;                         /* Titelzaehler                   */
main() {
  char *p = a; int c0, page;
  title *T = NULL; title *P = NULL;
  char dataf[20]; FILE *data;             /* Quelldatei: vol-01.data */
  sprintf(dataf,"vol-%s.data",vol);  /* Daten in ruecklaeufiger Reihenfolge */
  data = eopen(dataf,"r");
  while ( (c0 = getch(data)) != EOF ) {
    int cc; 
    switch (c0) {
      case '#': while ( (cc=getch(data)) != '\n' ) ; break;
      case '\\': cc = getch(data); 
	switch (cc) {
	  case 'A': if ( count++ != 0 ) {
	              *p = 0; 
	              sscanf(pp,"%d",&page);
		      P = T;
		      T = Title(a,t,c,d,x,page,T,NULL);
                      if (P) 
			P->p = T;
		      a[0]=t[0]=c[0]=d[0]=x[0]=0; page = 0;
		    }
	            p = a; break;
	  case 'T': *p = 0; p = t; break;
          case 'C': *p = 0; p = c; break;
          case 'D': *p = 0; p = d; break;
          case 'X': *p = 0; p = x; break;
	  case 'P': *p = 0; p = pp; break;
	  case '#': *p++ = '#';     break;
	  default: ungetch(cc); *p++ = c0; 
	  } break;
      default: *p++ = c0;
      }
  }
  *p = 0; 
  sscanf(pp,"%d",&page);
  P = T; T = Title(a,t,c,d,x,page,T,NULL);
  if (P)
    P->p = T;
  first_page(T);
  tex_out(T,count); 
  html_out(T,count);
}
/* html-Datei wird in ruecklaeufiger Reihenfolge gehalten,
   Tex-Datei in natuerlicher Reihenfolge */
int first_page(title *T) {
  if (T)
    for ( T->f = 1; T->n; T = T->n ) {
      T->n->f = T->f + T->pp;
      if ( T->pp % 2 )   /* Neue Arbeit auf ungerader Seite  */
	T->n->f++;
    }
}
 
/* ----------- Tex-Inhaltsverzeichnis vol-01.tex, Vorspann --------- */
char *tex_init = "\
\\pageno=-3\n\
\\hsize=13truecm\n\
\\vsize=20truecm\n\
\\hoffset=1.23truecm\n\
\\voffset=2truecm\n\
\n
\\font\\sixrm=cmr6\n\
\\font\\eightrm=cmr8\n\
\\font\\eightbf=cmbx8\n\
\\font\\scaps=cmcsc8\n\
\\font\\caps=cmcsc10                    %% Theorem, Lemma etc\n\
\\font\\ccaps=cccsc10                   %% Sections\n\
\\font\\Caps=cccsc10 scaled \\magstep1  %% Title\n\
\\let\\sc=\\eightrm                     %% \n\
\\def\\thmfont{\\it}\n\
\\def\\heute{\\number\\day.~\\ifcase\\month\\or 
           Januar \\or Februar \\or M\\\"arz \\or April \\or Mai \\or Juni 
           \\or Juli \\or August \\or September \\or Oktober \\or November 
           \\or Dezember \\fi \\number\\year}\n\
\\def\\heute{30. April 1996}\n\
\\centerline {\\Caps Documenta Mathematica}\n\
\\bigskip\n\
\\centerline {\\caps Journal der Deutschen Mathematiker-\\kern-1.5pt Vereinigung}\n\
\\bigskip\n\
\\centerline {\\caps Band 1, 1996}\n\
\\bigskip\n\
\\centerline {\\scaps Stand vom \\heute}
\\caps\n\
\\noindent\n\
\\bigskip\\bigskip\n\
\n

\\halign{ #\\hfill                        & \\qquad\\qquad \\hfill#  \\cr\n";

int tex_out(title *T, int count) {
  char texf[20]; FILE *tex;        /* Zieldatei: vol-01.tex */
  sprintf(texf,"vol-%s.tex",vol);  /* Daten in natuerlicher Reihenfolge */
  tex = eopen(texf,"w"); 
  fprintf(tex,tex_init);
  while (T) { 
    char dd[LEN]; char *p, *q;
    /* Autorenzeilen */
    p = T->a; q = dd;
    while ( *q++ = *p++ ) {
      if ( q[-1] == '<' ) {       /* Ausschalten von < ... > */
	q--; 
	while ( *p != '>' && *p)
	  p++;
	if (*p == '>')
	  p++;
      }
      if ( q[-1] == '\n') {
	q[-1] = 0;
	fprintf(tex, "%-50s&            \\cr\n", dd);
	q = dd;
      } 
    }
    fprintf(tex, "\\noalign{\\smallskip}\n");

    /* Titelzeilen, letzte muss Seitenzahlen aufnehmen */
    p = T->t; q = dd;
    while ( *q++ = *p++ ) {
      if ( q[-1] == '\n') {
	q[-1] = 0;
	if (p[0]) 
	  fprintf(tex, "\\ %-48s&            \\cr\n", dd);
	else
	  fprintf(tex, "\\ %-48s&  %3d--%3d  \\cr\n", dd, T->f, T->f+T->pp-1);
	q = dd;
      } 
    }
    fprintf(tex,"\\noalign{\\bigskip\\goodbreak}\n");
    T = T->n;
  }
  fprintf(tex, "}\n\\vfill\\eject\n\\phantom{..}\n\\end\n");
}
/* --- textohtml wandelt Tex-Umlaute usw. in html-Versionen --------- */
/* p zeigt auf einen Tex-String als Quelle, q zeigt auf html-String als Ziel */
/* In p muessen Umlaute usw mit \ eingeleitet werden !! */
textohtml(char *q, char *p) {
  while ( *p ) {
    if ( *p != '\\' ) /* kopiere alles, was nicht hinter \ steht */
      *q++ = *p++;
    else { 
      if ( p[1] == '"') {                           /* Umlaut */
	p+=2;
	*q++ = '&'; *q++ = *p++; 
	*q++ = 'u'; *q++ = 'm'; *q++ = 'l'; *q++ = ';';
      }
      else if (p[1] == '\'') {
	p+=2;
	switch (*p) {
	case 'E':  *q++= 0311; p++; break;
	case 'e':  *q++= 0351; p++; break;
	case 'u':  *q++= 0372; p++; break;
	default:   *q++= *p++; break;
	}
      }
      else if (p[1] == 'c') {
	p+=3;
	switch (*p) {
	case 'c':  *q++= 0347; p++; break;
	default:   *q++= *p++; break;
	}
      }
      else if (p[1] == 's' && p[2] == 's' ) {       /* Eszet */
	p+=3;
	*q++ = '&'; *q++ = 's'; *q++ = 'z';
	*q++ = 'l'; *q++ = 'i'; *q++ = 'g'; *q++ = ';';
	if ( *p == ' ' || *p == '\\' )
	  p++;
      }
      else
	*q++ = *p++;
    }
  }
  *q=0;
}  
/* ----------- html-Inhaltsverzeichnis vol-01.html, Vorspann -------- */
char *html_init = "\
<TITLE>Documenta Mathematica: Band 1, 1996</TITLE>\n\
<H1>Documenta Mathematica</H1> \n\
<H2>Journal der Deutschen Mathematiker-Vereinigung</H2>\n\
\n\
<H3><A HREF=\"#Volume\">Band 1, 1996</A></H3>\n\
\n\
Inhaltsverzeichnis: <A HREF=\"vol-01.dvi.gz\">dvi.gz</A>, <A HREF=\"vol-01.dvi\">dvi</A>, <A HREF=\"vol-01.ps.gz\">ps.gz</A>\n\
<PRE>\n\
\n";

char *html_init_eng = "\
<TITLE>Documenta Mathematica: Volume 1, 1996</TITLE>\n\
<H1>Documenta Mathematica</H1> \n\
<H2>Journal der Deutschen Mathematiker-Vereinigung</H2>\n\
\n\
<H3><A HREF=\"#Volume\">Volume 1, 1996</A></H3>\n\
\n\
Table of contents: <A HREF=\"vol-01.dvi.gz\">dvi.gz</A>, <A HREF=\"vol-01.dvi\">dvi</A>, <A HREF=\"vol-01.ps.gz\">ps.gz</A>\n\
<PRE>\n\
\n";


/*
<P> Titel/Title:                 <A HREF=\"vol-01-title.dvi.gz\">dvi.gz</A>-, <A HREF=\"vol-01-title.dvi\">dvi</A>- und <A HREF=\"vol-01-title.ps.gz\">ps.gz</A>\
*/

char *html_end = "\
<P>\n";

int html_out(title *T, int count) {
  int ht=0, dvi=0, dvigz=0, ps=0, tot=0;
  int nr=0;
  struct stat bf; char fname[30]; int size;
  title *TT;
  char htmlf[20], htmlf_eng[20]; 
  FILE *html, *html_eng;        /* Zieldatei: vol-01.html. vol-01-eng.html */
  sprintf(htmlf,"vol-%s.html",vol);  /* Daten in ruecklaeufiger Reihenfolge */
  sprintf(htmlf_eng,"vol-%s-eng.html",vol);
  html = eopen(htmlf,"w"); html_eng = eopen(htmlf_eng,"w"); 
  fprintf(html,html_init,vol,vol,vol);
  fprintf(html_eng,html_init_eng,vol,vol,vol);
/* reverse order 
  while(T) {                         
    TT = T; T = T->n;
  }
  T = TT;
*/
  while(T) { int ii=0;
    char d[LEN], h[LEN]; char *p, *q;
    /* html Autorenzeilen */
    textohtml(h,T->a);
    p = h; q = d; nr++;
    fprintf(html,     "<P>%3d.",nr);    
    fprintf(html_eng, "<P>%3d.",nr);
    while ( *q++ = *p++ ) {
      if ( q[-1] == '\n') {
	q[-1] = 0; 
	if (ii) {
	  fprintf(html,       "       %s\n", d);
	  fprintf(html_eng,   "       %s\n", d);
	}
	else {
	  fprintf(html,       "   %s\n", d);
	  fprintf(html_eng,   "   %s\n", d);
	}
	q = d; ii++;
      } 
    }
    textohtml(h,T->t);
    p = h; q = d;
    while ( *q++ = *p++ ) {
      if ( q[-1] == '\n') {
	q[-1] = 0;
	fprintf(html,       "       %s\n", d);
	fprintf(html_eng,   "       %s\n", d);
	q = d;
      }
    }
    fprintf(html,     "       %d-%d\n", T->f, T->f+T->pp-1);
    fprintf(html_eng, "       %d-%d\n", T->f, T->f+T->pp-1);
    textohtml(h,T->c);
    p = h; q = d; ii=0;
    while ( *q++ = *p++ ) {
      if ( q[-1] == '\n') {
	q[-1] = 0;
	if (ii) {
	  fprintf(html_eng,   "       %s\n", d);
	}
	else {
	  fprintf(html_eng,   "       %s\n", d);
	}
	q = d; ii++;
      }
    }    
    textohtml(h,T->d);
    p = h; q = d; ii=0;
    while ( *q++ = *p++ ) {
      if ( q[-1] == '\n') {
	q[-1] = 0;
	if (ii) {
	  fprintf(html,   "       %s\n", d);
	}
	else {
	  fprintf(html,   "       %s\n", d);
	}
	q = d; ii++;
      }
    }    
    
    { 
/* Abstract */
      fprintf(html,    "       ");
      fprintf(html_eng,"       ");
      sprintf(fname,"%02d.html",nr);
      if (stat(fname,&bf) == 0) 
	size = bf.st_size/1000 + 1;
      else
	size = 0;
      ht += size; tot += size;
      fprintf(html,     "<A HREF=\"%s\">Abstract</A> %dk, ",fname,size);
      fprintf(html_eng, "<A HREF=\"%s\">Abstract</A> %dk, ",fname,size);
/* dvi.gz  */
      sprintf(fname,"%02d.dvi.gz",nr);
      if (stat(fname,&bf) == 0) 
	size = bf.st_size/1000 + 1;
      else
	size = 0;
      dvigz += size; tot += size;
      fprintf(html,     "<A HREF=\"%s\">dvi.gz</A> %dk, ",fname,size);
      fprintf(html_eng, "<A HREF=\"%s\">dvi.gz</A> %dk, ",fname,size);
/* dvi */
      sprintf(fname,"%02d.dvi",nr);
      if (stat(fname,&bf) == 0) 
	size = bf.st_size/1000 + 1;
      else
	size = 0;
      dvi += size; tot += size;
      fprintf(html,     "<A HREF=\"%s\">dvi</A> %dk, ",fname,size);
      fprintf(html_eng, "<A HREF=\"%s\">dvi</A> %dk, ",fname,size);
/* ps.gz */
      sprintf(fname,"%02d.ps.gz",nr);
      if (stat(fname,&bf) == 0) 
	size = bf.st_size/1000 + 1;
      else
	size = 0;  
      ps += size; tot += size;
      fprintf(html,     "<A HREF=\"%s\">ps.gz</A> %dk\n",fname,size);
      fprintf(html_eng, "<A HREF=\"%s\">ps.gz</A> %dk\n",fname,size);
      fprintf(html,    "<P>\n");
      fprintf(html_eng,"<P>\n");
    }
    T = T->n;
  }
  if (stat("vol-01-all.ps.gz",&bf) == 0)
      size =  bf.st_size/1000 + 1;
  fprintf(html,    "\n</PRE>\nGesamtdaten:\n\
Abstracts: %dk, dvi.gz: %dk, dvi: %dk, ps.gz: %dk, \
total: %dk\n<HR>",ht,dvigz,dvi,ps,tot);
  fprintf(html_eng,"\n</PRE>\nTotal data:\n\
Abstracts: %dk, dvi.gz: %dk, dvi: %dk, ps.gz: %dk, \
total: %dk\n<HR>",ht,dvigz,dvi,ps,tot);

  fprintf(html,"<P>\n\
<A NAME = \"Volume\">\n\
<H3> Gesamtband 1 </H3>\n\
Hier kann der <A HREF=\"vol-01-all.ps.gz\">gesamte Band 1 (ps.gz, %dk)</a>\n\
- bisher %d Manuskripte - angesehen, kopiert oder ausgedruckt werden.\n\
Die Datei ist vorbereitet f&uuml;r zweiseitigen Ausdruck im A4-Format.<P>\n\
<H3><A HREF= \"../Welcome.html\">Homepage von Documenta Mathematica</A></H3>\n",size,nr);
  fprintf(html_eng,"\n<P>\n\
<A NAME = \"Volume\">\n\
<H3> Total volume 1 </H3>\n\
Here you can view or download the <A HREF=\"vol-01-all.ps.gz\">\n\
total volume 1 (ps.gz, %dk)</A> - up to now, %d Manuscripts.\n\
The file is prepared for twosided printout in A4 format.<P>\n\
<H3><A HREF= \"../Welcome-eng.html\">Homepage of Documenta Mathematica</A></H3>\n",size,nr);

  fprintf(html,"\n%s\n", html_end);
  fprintf(html_eng,"\n%s\n", html_end);
}

#define BUFSIZE 100
char buf[BUFSIZE];
int bufp = 0;

int getch(FILE *in) {
  return(bufp > 0) ? buf[--bufp] : getc(in);
}
ungetch(int c) {
  if ( bufp >= BUFSIZE ) {
    printf("ungetch: too many characters\n");
    return 0;
  }
  else {
    buf[ bufp++ ] = c;
    return 1;
  }
}
